program neuner;
{ 3 Reihen zu 9 Karten verdeckt austeilen, wechselnde Farben zusammen- }
{ legen, kein Stack, Reihen auslegen, die 1.,2., und 6. verdeckt       }
{ 18.05.96:   Karten, Markierungen, Neu, Quit, Reihe legen, Ablage,    }
{             Regeln fr Sortieren, Ablage, 1.spielbare Version        }
{ 19.05.96:   Version 1.000: Help-Screen, Fanfare, Keyboard-Steuerung  }

{$M 8192,0,655360}
uses crt,dos,graph,drivers,intuit;

const titel='        Neuner-Patience Langform  -   uja Vers.1.000             TP6.01';
      dx=56; dy=10; ysize=80; ox=-52; oy=20; sx=10*dx+ox+16; sy=oy+20;
      imafil='cards.ima';
      pal:array[0..15,0..2] of word=(
         ( 0, 0, 0),( 0, 0,42),( 0,27, 0),(49,55,55),
         (42, 5, 0),( 0,24,23),(30, 0, 0),(44,39,35),
         (21,21,21),(21,21,63),(21,63,21),(21,63,63),
         (63,27,11),(59,52,51),(63,46, 0),(61,58,56));

var ok,ende,fertig     :boolean;
    cardmark,cardmask  :array[1..4] of Image;
    itext1,itext2      :array[1..4] of Intuitext;
    ibord1,ibord2      :Border;
    xy,xy2             :Koords;
    bgr1,bgr2,mask,leer:Image;
    igad               :array[1..24] of Gadget;
    g,mx,my,x,y,index,i:integer;
    ch                 :char;
    karte              :array[1..52] of Image;
    talon,cards        :array[0..104] of word;
    ablage             :array[1..8] of word;
    reihen             :array[1..9,0..79] of word;
    sichtbar           :array[1..9,0..79] of boolean;
{ ------------------------------------------------------------------------ }

{ === Karten - allgemeiner Teil ========================================== }

procedure getimages;
var i:integer;
    anz:word;
    fh:file;
begin
   assign(fh,imafil);
   reset(fh,1);
   for i:=1 to 52 do begin
      BlockRead(fh,karte[i],sizeof(image),anz);
      anz:=Imagesize(1,1,karte[i].width,karte[i].height);
      GetMem(karte[i].p_data,anz);
      BlockRead(fh,karte[i].p_data^,anz,anz);
   end;
   for i:=1 to 4 do begin
      BlockRead(fh,cardmask[i],sizeof(image),anz);
      anz:=Imagesize(1,1,cardmask[i].width,cardmask[i].height);
      GetMem(cardmask[i].p_data,anz);
      BlockRead(fh,cardmask[i].p_data^,anz,anz);
      BlockRead(fh,cardmark[i],sizeof(image),anz);
      anz:=Imagesize(1,1,cardmark[i].width,cardmark[i].height);
      GetMem(cardmark[i].p_data,anz);
      BlockRead(fh,cardmark[i].p_data^,anz,anz);
   end;
   BlockRead(fh,leer,sizeof(image),anz);
   anz:=Imagesize(1,1,leer.width,leer.height);
   GetMem(leer.p_data,anz);
   BlockRead(fh,leer.p_data^,anz,anz);
   BlockRead(fh,bgr1,sizeof(image),anz);
   anz:=Imagesize(1,1,bgr1.width,bgr1.height);
   GetMem(bgr1.p_data,anz);
   BlockRead(fh,bgr1.p_data^,anz,anz);
   BlockRead(fh,bgr2,sizeof(image),anz);
   anz:=Imagesize(1,1,bgr2.width,bgr2.height);
   GetMem(bgr2.p_data,anz);
   BlockRead(fh,bgr2.p_data^,anz,anz);
   close(fh);
end;

procedure setcolors;
var i:integer;
begin
for i:=0 to 15 do begin
   setrgbpalette(i,pal[i,0],pal[i,1],pal[i,2]);
   setpalette(i,i);
end;
end;

{ ------------------------------------------------------------------------ }

procedure anhalten;
var ch:char;  g,mx,my:integer;
begin
ch:=chr(0);
g:=0;
showmouse;
   repeat
      maustastelos(g,mx,my);
      if keypressed then ch:=readkey
   until (ch<>chr(0)) or (g<>0);
hidemouse;
end;



procedure intuikram;
var i:integer;
begin
   for i:=1 to 4 do with itext1[i] do begin
      x:=8; y:=5; fpen:=15; bpen:=7; p_nexttext:=addr(itext2[i]);
      case i of
      1: itext:=' Neu';
      2: itext:=' Quit';
      3: itext:='Reihe';
      4: itext:='Stack';
      end;
   end;
   for i:=1 to 4 do with itext2[i] do begin
      x:=pred(itext1[i].x); y:=itext1[i].y; fpen:=0; bpen:=itext1[i].bpen;
      itext:=itext1[i].itext; p_nexttext:=nil;
   end;

   xy[0]:=0;  xy[1]:=0; xy[2]:=56;  xy[3]:=0; xy[4]:=56;
   xy[5]:=15; xy[6]:=0; xy[7]:=15;  xy[8]:=0; xy[9]:=0;
   xy2[0]:=0;  xy2[1]:=0; xy2[2]:=112; xy2[3]:=0; xy2[4]:=112;
   xy2[5]:=15; xy2[6]:=0; xy2[7]:=15;  xy2[8]:=0; xy2[9]:=0;
   with ibord1 do begin
      x:=1; y:=1; fpen:=15; bpen:=7; ecken:=5; p_ecken:=addr(xy);
      p_nextborder:=addr(ibord2);
   end;
   with ibord2 do begin
      x:=0; y:=0; fpen:=0; bpen:=7; ecken:=5; p_ecken:=addr(xy);
      p_nextborder:=nil;
   end;

{ neu, quit: }
   for i:=1 to 2 do with igad[i] do begin
      id:=i;
      x:=sx+pred(i)*dx;
      y:=460;
      width:=dx;
      height:=16;
      bpen:=7;
      hibpen:=bpen;
      p_loborder:=addr(ibord1);
      p_hiborder:=p_loborder;
      p_loimage:=nil;
      p_hiimage:=nil;
      p_lointuitext:=addr(itext1[i]);
      p_hiintuitext:=p_lointuitext;
      gadgettyp:=boolgadget;
      onoff:=false;
      active:=true;
      p_specialinfo:=nil;
      p_nextgadget:=addr(igad[succ(i)]);
   end;

{ stack: }
  i:=3;
  with igad[i] do begin
      id:=i;
      x:=sx;
      y:=oy+dy;
      width:=2*dx;
      height:=ysize;
      bpen:=-1;
      hibpen:=bpen;
      p_loborder:=nil;
      p_hiborder:=p_loborder;
      p_loimage:=nil;
      p_hiimage:=nil;
      p_lointuitext:=nil;
      p_hiintuitext:=p_lointuitext;
      gadgettyp:=boolgadget;
      onoff:=false;
      active:=true;
      p_specialinfo:=nil;
      p_nextgadget:=addr(igad[succ(i)]);
   end;

   { Ablagen: }
   for i:=1 to 8 do with igad[i+3] do begin
      id:=i+3;
      if i<5 then x:=sx else x:=sx+dx;
      if i<5 then y:=i*ysize+sy else y:=(i-4)*ysize+sy;
      width:=dx;
      height:=ysize;
      bpen:=-1;
      hibpen:=bpen;
      p_loborder:=nil;
      p_hiborder:=p_loborder;
      p_loimage:=nil;
      p_hiimage:=nil;
      p_lointuitext:=nil;
      p_hiintuitext:=p_lointuitext;
      gadgettyp:=boolgadget;
      onoff:=false;
      active:=true;
      p_specialinfo:=nil;
      p_nextgadget:=addr(igad[succ(i+3)]);
   end;

{ Reihen: }
   for i:=1 to 9 do with igad[i+11] do begin
      id:=i+11;
      x:=i*dx+ox;
      y:=oy+dy;
      width:=dx;
      height:=480-y;
      bpen:=-1;
      hibpen:=bpen;
      p_loborder:=nil;
      p_hiborder:=p_loborder;
      p_loimage:=nil;
      p_hiimage:=nil;
      p_lointuitext:=nil;
      p_hiintuitext:=p_lointuitext;
      gadgettyp:=boolgadget;
      onoff:=false;
      active:=true;
      p_specialinfo:=nil;
      p_nextgadget:=addr(igad[succ(i+11)]);
   end;

{ Reihe auslegen und Stack belegen: }
  for i:=21 to 22 do with igad[i] do begin
      id:=i;
      x:=sx+(i-21)*dx;
      y:=445;
      width:=dx;
      height:=16;
      bpen:=7;
      hibpen:=bpen;
      p_loborder:=addr(ibord1);
      p_hiborder:=p_loborder;
      p_loimage:=nil;
      p_hiimage:=nil;
      p_lointuitext:=addr(itext1[i-18]);
      p_hiintuitext:=p_lointuitext;
      gadgettyp:=boolgadget;
      onoff:=false;
      active:=true;
      p_specialinfo:=nil;
      if i=22 then p_nextgadget:=nil else p_nextgadget:=addr(igad[succ(i)]);
   end;
end;

{ ------------------------------------------------------------------------ }

procedure darken;
var i:integer;
begin
for i:=1 to 15 do setpalette(i,0);
end;

procedure lighten;
var i:integer;
begin
for i:=1 to 15 do setpalette(i,i);
end;

procedure buildscreen(reihen,stacks:word);
var i:integer;
    b1,b2:Border;
    xy   :Koords;
    temp:string;
begin
{ Background: }
   xy[0]:=0;  xy[1]:=0; xy[2]:=631; xy[3]:=0; xy[4]:=631;
   xy[5]:=15; xy[6]:=0; xy[7]:=15;  xy[8]:=0; xy[9]:=0;
   with b1 do begin
      x:=1; y:=1; fpen:=15; bpen:=7; ecken:=5; p_ecken:=addr(xy);
      p_nextborder:=addr(b2);
   end;
   with b2 do begin
      x:=0; y:=0; fpen:=0; bpen:=7; ecken:=5; p_ecken:=addr(xy);
      p_nextborder:=nil;
   end;
   rectfill(0,0,639,479,5);
   rectfill(2,2,635,17,7);
   DrawBorder(2,2,addr(b1));
   setcolor(15); outtextxy(33,7,titel);
   setcolor(0);  outtextxy(32,7,titel);
   putimage(510,5,cardmask[1].p_data^,andput);
   putimage(511,5,cardmark[1].p_data^,orput);
   for i:=2 to 4 do begin
      putimage(i*16-20,5,cardmask[i].p_data^,andput);
      putimage(i*16-19,5,cardmark[i].p_data^,orput);
   end;
{ Talon: }
   putimage(sx,oy+dy,bgr1.p_data^,normalput);
   putimage(sx+dx,oy+dy,bgr2.p_data^,normalput);
{ Ablagen: }
   for i:=1 to 4 do begin
      putimage(sx,sy+i*ysize,bgr2.p_data^,normalput);
      putimage(sx+23,sy+i*ysize+36,cardmask[i].p_data^,andput);
      putimage(sx+24,sy+i*ysize+36,cardmark[i].p_data^,orput);
      if stacks>4 then begin
         putimage(sx+dx,sy+i*ysize,bgr2.p_data^,normalput);
         putimage(sx+dx+23,sy+i*ysize+36,cardmask[i].p_data^,andput);
         putimage(sx+dx+24,sy+i*ysize+36,cardmark[i].p_data^,orput);
      end;
   end;
{ fr Neuner - kein Talon: }
   with igad[3] do rectfill(x,y,x+width,y+height,5);
   setcolor(15);
   for i:=1 to reihen do begin
      temp:=chr(i+48);
      outtextxy(i*dx+ox+25,22,temp);
   end;
   setcolor(0);
   for i:=1 to reihen do begin
      temp:=chr(i+48);
      outtextxy(i*dx+ox+24,22,temp);
   end;
{ Markierungen fr keyboard-Mode: }
  setcolor(15);
   for i:=1 to 4 do begin
      temp:=chr(i+64);
      outtextxy(sx+25,oy+2*i*dy,temp);
      if stacks>4 then begin
         temp:=chr(i+68);
         outtextxy(sx+dx+25,oy+2*i*dy,temp);
      end;
   end;
   setcolor(0);
   for i:=1 to 4 do begin
      temp:=chr(i+64);
      outtextxy(sx+24,oy+2*i*dy,temp);
      if stacks>4 then begin
         temp:=chr(i+68);
         outtextxy(sx+dx+24,oy+2*i*dy,temp);
      end;
   end;
   for i:=1 to 8 do if i>stacks then igad[i+ 3].active:=false;
   for i:=1 to 9 do if i>reihen then igad[i+11].active:=false;
   RefreshGadgets(addr(igad[1]));
end;

procedure mischen;
var i,j,k:integer;
begin
   for i:=1 to 8 do ablage[i]:=0;
   for i:=1 to 9 do reihen[i,0]:=0;
   for i:=1 to 52 do cards[i]:=i;
   if cards[0]>52 then for i:=1 to 52 do cards[i+52]:=i;
   randomize;
   for i:=1 to cards[0] do begin
      j:=succ(random(1000) mod cards[0]);
      k:=cards[i];
      cards[i]:=cards[j];
      cards[j]:=k;
   end;
   talon:=cards;
end;


procedure auslegen(nrow:word; offen:boolean);
var i,j,k:integer;
    temp:string;
begin
   for i:=1 to nrow do if talon[0]>0 then begin
      inc(reihen[i,0]);
      k:=reihen[i,0];
      reihen[i,k]:=talon[talon[0]];
      sichtbar[i,k]:=offen;
      dec(talon[0]);
      if offen then
      putimage(i*dx+ox,k*dy+oy,karte[reihen[i,k]].p_data^,normalput)
      else
      putimage(i*dx+ox,k*dy+oy,bgr1.p_data^,normalput);
   end;
   str(talon[0]:3,temp);
   temp:='Rest:'+temp+' Karten';
   rectfill(sx-12,oy,sx+2*dx-1,oy+dy,1);
   setcolor(0); outtextxy(sx-10,oy+2,temp);
   setcolor(0); outtextxy(sx-8,oy+2,temp);
   setcolor(9);  outtextxy(sx-9,oy+2,temp);
end;

procedure markiere(n,p:integer);
var x,y,z:integer;
begin
   if n<11 then begin
      x:=n*dx+ox;
      y:=p*dy+oy;
      putimage(x,y,leer.p_data^,andput);
      putimage(x,y+leer.height,leer.p_data^,andput);
   end else begin
      z:=n-10;
      x:=sx;
      if z>4 then begin x:=x+dx; z:=z-4; end;
      y:=sy+ysize*z;
      putimage(x,y,bgr2.p_data^,andput);
   end;
end;

procedure zeichnereihe(n:integer);
{ updatet Reihe mit Sichtbarkeit }
var i:integer;
begin
rectfill(ox+n*dx,oy+dy,pred(ox+succ(n)*dx),479,5);
if reihen[n,0]>0 then begin
for i:=1 to reihen[n,0] do begin
if i=reihen[n,0] then sichtbar[n,i]:=true;
if sichtbar[n,i] then putimage(ox+n*dx,oy+i*dy,karte[reihen[n,i]].p_data^,normalput)
                 else putimage(ox+n*dx,oy+i*dy,bgr1.p_data^,normalput);
end;
end else putimage(ox+n*dx,oy+dy,bgr2.p_data^,andput);
end;

procedure demarkiere(n,p:integer);
var a,x,y,z:integer;
begin
   if n<11 then zeichnereihe(n) else begin
      z:=n-10;    { Stack }
      a:=z;
      x:=sx; if z>4 then begin x:=x+dx; z:=z-4; end;
      y:=sy+z*ysize;
      if ablage[a]=0 then begin
         putimage(x,y,bgr2.p_data^,normalput);
         putimage(x+19,y+36,cardmask[z].p_data^,andput);
         putimage(x+20,y+36,cardmark[z].p_data^,orput);
      end else begin
         z:=pred(z)*13+ablage[a];
         putimage(x,y,karte[z].p_data^,normalput);
      end;
   end;
end;

{ ======================================================================== }
procedure neuner_1a;
var i:integer;
begin
   for i:=1 to 2 do auslegen(9,false);
   auslegen(9,true);
   index:=3;
end;

procedure checkablage(nr,na:word; var ok:boolean);
var e1,e2,f1,f2,g1,g2:integer;
begin
   ok:=(nr>0) and (nr<11);
   ok:=ok and (ablage[na]<13);
   if ok then begin
      e1:=succ(ablage[na]);
      e2:=reihen[nr,reihen[nr,0]];
      f1:=e1 mod 13;
      f2:=e2 mod 13;
      g1:=pred(e2) div 13;
      g2:=pred(na) mod 4;
      ok:=(f1=f2) and (g1=g2);
   end;
end;

function sequenz(nr1,np1,nr2,np2:word):boolean;
var e1,e2:word;
    seq  :boolean;
begin
   seq:=false;
   if sichtbar[nr1,np1] then begin
      e1:=pred(reihen[nr1,np1]);
      e2:=pred(reihen[nr2,np2]);
      seq:=(e1 in [0..25]) and (e2 in [26..51]);
      seq:=seq or (e2 in [0..25]) and (e1 in [26..51]);
   end;
   sequenz:=seq and ((reihen[nr2,np2] mod 13)=(succ(reihen[nr1,np1]) mod 13));
end;

procedure checkreihen(n1,n2,y:word; ok:boolean);
{ an die unterste Karte von der Reihe n2 die passende von n1 anlegen }
var e,i,k1,k2      :integer;
    weiter,gefunden:boolean;
begin
   k2:=reihen[n2,0];
   if y>0 then gefunden:=sequenz(n1,y,n2,k2);
   if gefunden then k1:=y else begin
      k1:=reihen[n1,0];
      weiter:=true;
      while (k1>0) and weiter do begin
         gefunden:=sequenz(n1,k1,n2,k2);
         weiter:=not gefunden;
         if weiter then if sequenz(n1,k1,n1,k1-1) then dec(k1) else weiter:=false;
      end;
   end;
   if gefunden then begin
      for i:=k1 to reihen[n1,0] do begin
         inc(reihen[n2,0]);
         sichtbar[n2,reihen[n2,0]]:=true;
         reihen[n2,reihen[n2,0]]:=reihen[n1,i];
         dec(reihen[n1,0]);
      end;
      zeichnereihe(n1);
      zeichnereihe(n2);
   end;
end;

procedure reihehoch(n1,n2,y:word; var ok:boolean);
{ Reihe hochlegen von nach n2 }
var i,k1,k2:integer;
    weiter :boolean;
begin
   ok:=true;
   if y>0 then k1:=y else begin
      weiter:=true;
      k1:=reihen[n1,0];
      while weiter and (k1>1) do begin
         weiter:=sequenz(n1,k1,n1,k1-1);
         weiter:=weiter and sichtbar[n1,k1-1];
         if weiter then dec(k1);
      end;
   end;
   for i:=k1 to reihen[n1,0] do begin
      inc(reihen[n2,0]);
      sichtbar[n2,reihen[n2,0]]:=true;
      reihen[n2,reihen[n2,0]]:=reihen[n1,i];
      dec(reihen[n1,0]);
   end;
   zeichnereihe(n1);
   zeichnereihe(n2);
end;

procedure aufraeumen(reihe,stacks:word);
var i,j,k1,k2,k3:integer;
    weiter,ok:boolean;
begin
   weiter:=true;
   while weiter do begin
      weiter:=false;
      for i:=1 to reihe do if reihen[i,0]>0 then begin
         j:=0;
         ok:=false;
         while (j<stacks) and (not ok) do begin
            inc(j);
            checkablage(i,j,ok);
            if ok then begin
               dec(reihen[i,0]);
               zeichnereihe(i);
               inc(ablage[j]);
               demarkiere(j+10,y);
               weiter:=true;
            end;
         end;
      end;
   end;
end;

procedure fanfare;
var i,x,y,a,a1,a2:integer;
    r1,r2  :real;
    temp   :string;
begin
randomize;
i:=52*50-13;
a:=0;
while (i>0) and not keypressed do begin
   dec(i);
   r1:=i*0.15;
   r2:=i*0.10;
   x:=trunc(r1*sin(r2))+320;
   y:=trunc(r2*cos(r1))+240;
   a:=a+1; if a>52 then a:=a-52;
   putimage(x,y,karte[a].p_data^,normalput);
   delay(5);
end;
x:=16; y:=460;
rectfill(x-8,y-8,x+480,y+16,0);
rectfill(x-7,y-7,x+479,y+15,15);
rectfill(x-6,y-6,x+478,y+14,7);
temp:=' -  zum Spiel: beliebige Taste drcken - Ende: [esc] - ';
setcolor(15); outtextxy(x,y,temp);
setcolor(0);  outtextxy(pred(x),y,temp);
ch:=readkey; if ch=#0 then ch:=readkey;
ende:=ch=#27;
if not ende then begin
   buildscreen(9,8);
   mischen;
   neuner_1a;
   for i:=1 to 18 do if i<>10 then demarkiere(i,0);
end;
end;

procedure helpscreen;
const ofy=12;
var c,i,x1,x2,y1,y2:integer;
    temp          :string;
begin
x1:=32; y1:=48; x2:=x1+560; y2:=y1+320;
rectfill(x1,y1,x2,y2,0);
inc(x1); inc(y1); dec(x2); dec(y2);
rectfill(x1,y1,x2,y2,15);
inc(x1); inc(y1); dec(x2); dec(y2);
rectfill(x1,y1,x2,y2,7);
putimage(574,350,cardmask[1].p_data^,andput);
putimage(575,350,cardmark[1].p_data^,orput);

x1:=x1+8;
for i:=1 to 21 do begin
   case i of
   1                  : y1:=y1+8;
   2,7,9              : y1:=y1+16;
   3..6,8,10,12..16,19: y1:=y1+ofy;
   11                 : y1:=y1+24;
   17,18,20           : y1:=y1+10;
   21                 : y1:=y1+40;
   end;
   case i of
   1,9..16,19,21 : c:=0;
   2..6          : c:=1;
   7..8          : c:=6;
   17,18,20      : c:=8;
   end;

   case i of
   1: temp:='N e u n e r - P a t i e n c e:';
   2: temp:='Ziel ist es, alle Karten auf die Stacks zu sammeln, wobei die Farben';
   3: temp:='gleich sein sollten und die Werte ansteigend (z.B. KAs,K2,K3,K4...).';
   4: temp:='Die Spalten werden mit absteigenden Werten gebildet, wobei die roten';
   5: temp:='mit den schwarzen Karten abwechseln mssen(Sequenz). Ist eine Spalte';
   6: temp:='leer, so kann eine freie Sequenz an deren Stelle gelegt werden.     ';
   7: temp:='Bei der Neuner werden die ersten 2 Reihen sowie die 6. verdeckt aus-';
   8: temp:='gelegt. Man kann diese Karten ffnen,indem man bis zu ihnen abrumt.';
   9: temp:='Zunchst mu man die zu verschiebende Karte/Sequenz whlen, dann das';
   10: temp:='Ziel. Bei gltiger Wahl wird der Zug durchgefhrt.';
   11: temp:='Steuerung              mit Keyboard:             mit Maus:';
   12: temp:='neues Spiel           :  [N]                     [  Neu ]';
   13: temp:='Ende                  :  [Q],[esc]               [ Quit ]';
   14: temp:='Reihe auslegen        :  [R]                     [ Reihe]';
   15: temp:='auf dem Stack ablegen :  [S]                     [ Stack]';
   16: temp:='Karte in Reihen whlen:  [1] bis [9]             Karte anklicken';
   17: temp:='die passende Karte wird vom Spiel gesucht';
   18: temp:='die zu verschiebende Karte wird markiert';
   19: temp:='Karte vom Stack whlen:  [A] bis [H]             Karte anklicken';
   20: temp:='die zu verschiebende Karte wird markiert';
   21: temp:=' -  zum Spiel: beliebige Taste drcken - Ende: [esc] - ';
   end;
   setcolor(15); outtextxy(x1,y1,temp);
   setcolor(c);  outtextxy(pred(x1),y1,temp);
end;

anhalten;

if not ende then begin
   buildscreen(9,8);
   for i:=1 to 18 do if i<>10 then demarkiere(i,0);
end;
end;


{ ======================================================================== }

begin
   initscreen(ok);
   if ok then begin
      setcolors;
      darken;
      getimages;
      intuikram;
      buildscreen(9,8);
      igad[3].active:=false;
      cards[0]:=104;
      lighten;
      mischen;
      neuner_1a;
      ende:=false;
      i:=0;
      y:=0;
      while not ende do begin
         showmouse;
         delay(50);
         getgadget(addr(igad[1]),g,mx,my);
         hidemouse;
         if keypressed then begin
            ch:=readkey;
            case ch of
            #0                : begin
                                   ch:=readkey;
                                   if ch=#59 then begin {Help}
                                      helpscreen;


                                   end;
                                end;
            #27,'Q','q'       : g:=2;
            'S','s'           : g:=22;
            'N','n'           : g:=1;
            'R','r'           : g:=21;
            '1'..'9'          : begin g:=ord(ch)-37; my:=oy+dy; end; {12-20}
            'A'..'H','a'..'h' : g:=ord(upcase(ch))-61;               { 4-11}

            end;
         end;
         case g of
         1: begin
               buildscreen(9,8);
               mischen;
               neuner_1a;
               i:=0;
            end;
         2: ende:=true;
         3: ;
         4..11: if i=0 then begin  { Ablagen }
                   i:=g+7;
                   if ablage[i-10]>0 then markiere(i,y) else i:=0;
                end else begin
                   checkablage(i,g-3,ok);
                   if ok then begin
                      dec(reihen[i,0]);
                      zeichnereihe(i);
                      inc(ablage[g-3]);
                      demarkiere(g+7,y);
                      i:=0;
                   end else begin
                      demarkiere(i,y);
                      i:=0;
                   end;
                end;
         12..20: if i=0 then begin  { Reihen }
                    y:=(my-oy) div dy;
                    i:=g-11;
                    if reihen[i,0]>0 then begin
                       if y>reihen[i,0] then y:=reihen[i,0];
                       my:=0;
                       if y<reihen[i,0] then for x:=reihen[i,0] downto y+1 do begin
                          if not sequenz(i,x,i,pred(x)) then if my=0 then my:=x;
                       end;
                       if my>0 then y:=my;
                       markiere(i,y);
                    end;
                 end else begin  { umschichten }
                    if i<11 then begin
                       if i<>(g-11) then begin
                          if reihen[g-11,0]=0 then reihehoch(i,g-11,y,ok)
                                              else checkreihen(i,g-11,y,ok);
                          if not ok then demarkiere(i,y);
                       end;
                    end else begin { Ablage auf Reihe }
                       if ablage[i-10]>0 then begin
                          reihen[g-11,succ(reihen[g-11,0])]:=ablage[i-10]+((i-11) mod 4)*13;
                          sichtbar[g-11,succ(reihen[g-11,0])]:=true;
                          if reihen[g-11,0]=0 then begin
                             inc(reihen[g-11,0]);
                             zeichnereihe(g-11);
                             dec(ablage[i-10]);
                          end else if sequenz(g-11,succ(reihen[g-11,0]),g-11,reihen[g-11,0]) then begin
                             inc(reihen[g-11,0]);
                             zeichnereihe(g-11);
                             dec(ablage[i-10]);
                          end;
                       end;
                    end;
                    if i>0 then demarkiere(i,y);
                    i:=0;
                 end;
         21: begin { Reihe auslegen }
               if i>0 then begin demarkiere(i,y); i:=0; y:=0; end;
               inc(index);
               if index=6 then auslegen(9,false);
               auslegen(9,true);
             end;
         22: begin
               if i>0 then begin
                  demarkiere(i,y);
                  y:=0;
                  i:=0;
               end;
               aufraeumen(9,8);
             end;
         end;
         fertig:=true;
         for mx:=1 to 9 do if reihen[mx,0]>0 then fertig:=false;
         if fertig then begin i:=0; fanfare; end;
      end;
   end;
   textmode(3);
end.

